Attribute VB_Name = "modFuncions"
Public Type AssocData
    MainSolution As String
    SolutionA As String
    SolutionB As String
    SolutionV As String
    SolutionG As String
    A(4) As String
    B(4) As String
    V(4) As String
    G(4) As String
End Type

Private DBConn As New ADODB.Connection
Dim SolutionList() As String

Public Function GetAssoc() As AssocData
    Dim rs As New ADODB.Recordset
    Dim SolutionCount As Integer
    Dim i As Integer
    
    'Otvaramo konekciju:
    DBConn.Open ("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & App.Path & "\" & "slagalica.mdb" & ";Persist Security Info=False")
    'Uzimamo sve primerke reci (nisam nikako uspeo da izvedem da
    'SQL uradi selekciju samo onih reci koje imaju bar 4 asocijacije):
    Call rs.Open("SELECT DISTINCT Word FROM Associates", DBConn, adOpenKeyset)
    ReDim tmpSList(rs.RecordCount) As String 'Koristimo ReDim da bismo dinamicki odredili duzinu niza
    Do Until rs.EOF
        'Ovo je malko zapetljano. Trazimo broj rezultata iz kolone Associate
        'gde je rec ona koja je trenutno selektovana u Recordset-u.
        'Zatim odmah proveravamo vrednost (da li je veca od 3)
        'i pustamo da nestane iz memorije (ne smestamo u promenljivu)
        If DBConn.Execute("SELECT COUNT(Associate) FROM Associates WHERE Word = '" _
                        & rs.Fields(0).Value & "'").Fields(0).Value > 3 Then
            'Ako jeste
            tmpSList(SolutionCount) = rs.Fields(0).Value 'Zapisujemo resenje
            SolutionCount = SolutionCount + 1 'Povecavamo broj dobrih resenja
        End If
        rs.MoveNext
    Loop
    ReDim SolutionList(SolutionCount - 1)
    For i = 0 To SolutionCount - 1
        SolutionList(i) = tmpSList(i) 'kopiramo samo one pocetne elemente koji sadrze resenja
    Next i
    GetAssoc.MainSolution = SolutionList(GetRandom(0, SolutionCount - 1))
    rs.Close
    Call rs.Open("SELECT Associate FROM Associates WHERE Word = '" & GetAssoc.MainSolution & "'", DBConn, adOpenKeyset)
    If rs.RecordCount = 4 Then 'ako jeste obilazimo uzimanje slucajnih jer ce ionako svi biti upotrebljeni
        GetAssoc.SolutionA = rs.Fields(0).Value
        rs.MoveNext
        GetAssoc.SolutionB = rs.Fields(0).Value
        rs.MoveNext
        GetAssoc.SolutionV = rs.Fields(0).Value
        rs.MoveNext
        GetAssoc.SolutionG = rs.Fields(0).Value
        rs.MoveNext
    Else
        Dim tmpUsedRnds(4) As Integer
        tmpUsedRnds(0) = GetRandom(0, rs.RecordCount - 1)
        rs.MoveFirst 'Za svaki slucaj (lakse nego da pratimo sve vreme kroz kod)
        rs.Move (tmpUsedRnds(0)) 'Pomeramo za random mesta
        GetAssoc.SolutionA = rs.Fields(0).Value 'Postavljamo resenje kolone A
Get1:
        tmpUsedRnds(1) = GetRandom(0, rs.RecordCount - 1)
        If tmpUsedRnds(1) = tmpUsedRnds(0) Then GoTo Get1 'Provera da li je vec koriscen ovaj slucajni br.
        'GoTo je uglavnom losa praksa ali je ovde u lokalu i privremeno
        'cemo ostaviti dok ne unapredimo GetRandom funkciju
        rs.MoveFirst
        rs.Move (tmpUsedRnds(1))
        GetAssoc.SolutionB = rs.Fields(0).Value
Get2:
        tmpUsedRnds(2) = GetRandom(0, rs.RecordCount - 1)
        If tmpUsedRnds(2) = tmpUsedRnds(0) Or tmpUsedRnds(2) = tmpUsedRnds(1) Then GoTo Get2
        rs.MoveFirst
        rs.Move (tmpUsedRnds(2))
        GetAssoc.SolutionV = rs.Fields(0).Value
Get3:
        tmpUsedRnds(3) = GetRandom(0, rs.RecordCount - 1)
        If tmpUsedRnds(3) = tmpUsedRnds(0) Or tmpUsedRnds(3) = tmpUsedRnds(1) Or tmpUsedRnds(3) = tmpUsedRnds(0) Then GoTo Get3
        rs.MoveFirst
        rs.Move (tmpUsedRnds(3))
        GetAssoc.SolutionG = rs.Fields(0).Value
    End If
    DBConn.Close
End Function

Private Function GetRandom(First As Integer, Last As Integer) As Integer
    Randomize
    GetRandom = First + Int(Rnd * (Last - First) + 1)
End Function
